<?php
function createNewSite($api_key, $email, $domain_name, $ip_address) {
    // Замените 'YOUR_API_KEY' на ваш Cloudflare API ключ
    $headers = array(
        'X-Auth-Email: ' . $email,
        'X-Auth-Key: ' . $api_key,
        'Content-Type: application/json'
    );

    // Создаем новый сайт в Cloudflare
    $data = array(
        'name' => $domain_name,
        'jump_start' => true
    );

    $ch = curl_init('https://api.cloudflare.com/client/v4/zones');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));

    $response = curl_exec($ch);
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($http_code !== 200) {
        echo "\n Произошла ошибка при создании сайта: " . $response;
        return;
    }

    $data = json_decode($response, true);
    $zone_id = $data['result']['id'];

    // Включаем функцию "Всегда использовать HTTPS"
    $https_data = array(
        'value' => 'on'
    );

    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/settings/always_use_https");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($https_data));

    $https_response = curl_exec($ch);
    $https_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($https_http_code !== 200) {
        echo "\n Произошла ошибка при включении функции 'Всегда использовать HTTPS': " . $https_response;
        return;
    }

    // Создаем DNS A-запись '@' на IP
    $dns_data = array(
        'type' => 'A',
        'name' => $domain_name,
        'content' => $ip_address,
        'proxied' => true
    );

    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/dns_records");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($dns_data));

    $dns_response = curl_exec($ch);
    $dns_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($dns_http_code !== 200) {
        echo "\n Произошла ошибка при создании DNS-записи: " . $dns_response;
        return;
    }

    // Создаем DNS A-запись 'www' на IP
    $www_dns_data = array(
        'type' => 'A',
        'name' => 'www',
        'content' => $ip_address,
        'proxied' => true
    );

    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/dns_records");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($www_dns_data));

    $www_dns_response = curl_exec($ch);
    $www_dns_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($www_dns_http_code !== 200) {
        echo "\n Произошла ошибка при создании DNS-записи для 'www': " . $www_dns_response;
        return;
    }

    echo "\n $domain_name успешно добавлен в Cloudflare, функция 'Всегда использовать HTTPS' включена, и DNS-записи созданы!";
}
?>
