<?php
function createNewSite($api_key, $email, $domain_name, $ip_address) {
    // Замените 'YOUR_API_KEY' на ваш Cloudflare API ключ
    $headers = array(
        'X-Auth-Email: ' . $email,
        'X-Auth-Key: ' . $api_key,
        'Content-Type: application/json'
    );

    // Создаем новый сайт в Cloudflare
    $data = array(
        'name' => $domain_name,
        'jump_start' => true
    );

    $ch = curl_init('https://api.cloudflare.com/client/v4/zones');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));

    $response = curl_exec($ch);
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($http_code !== 200) {
        $data = json_decode($response, true);
        if($data['errors'][0]['code']=='1061'){
             // Получаем Zone_id в Cloudflare
            $ch = curl_init("https://api.cloudflare.com/client/v4/zones?name=$domain_name");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

             $response = curl_exec($ch);
            $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            curl_close($ch);

            // Обрабатываем ответ от сервера
            if ($http_code !== 200) {
              echo "Произошла ошибка при получении zone_id:  $response  <br>";
             return;
             }
            $data = json_decode($response, true);
             if (isset($data['result'][0]['id'])) {
                $zone_id = $data['result'][0]['id'];
             } else {
             echo "Домен не найден в Cloudflare.";
                return;
                }
            // Получаем список всех DNS записей
    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/dns_records");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    $response = curl_exec($ch);
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($http_code !== 200) {
        echo "Произошла ошибка при получении списка DNS записей:  $response  <br>";
        return;
    }

    $data = json_decode($response, true);
    if (isset($data['result'])) {
        // Удаляем все DNS записи
        foreach ($data['result'] as $dns_record) {
            $record_id = $dns_record['id'];

            $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/dns_records/$record_id");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');

            $delete_response = curl_exec($ch);
            $delete_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            curl_close($ch);

            // Обрабатываем ответ от сервера
            if ($delete_http_code !== 200) {
                echo "Произошла ошибка при удалении DNS записи $record_id:  $delete_response <br>";
            }
        }

    } else {
        echo "Не удалось получить список DNS записей для домена $domain_name. <br>";
    }
            
        } else{
                echo " Произошла ошибка при создании сайта: $response <br>";
                return;
           }
    } else{
        $data = json_decode($response, true);
         $zone_id = $data['result']['id'];
    }


    // Включаем функцию "Всегда использовать HTTPS"
    $https_data = array(
        'value' => 'on'
    );

    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/settings/always_use_https");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($https_data));

    $https_response = curl_exec($ch);
    $https_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($https_http_code !== 200) {
        echo " Произошла ошибка при включении функции 'Всегда использовать HTTPS':  $https_response  <br>";
        return;
    }

    // Создаем DNS A-запись '@' на IP
    $dns_data = array(
        'type' => 'A',
        'name' => $domain_name,
        'content' => $ip_address,
        'proxied' => true
    );

    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/dns_records");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($dns_data));

    $dns_response = curl_exec($ch);
    $dns_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($dns_http_code !== 200) {
        echo " Произошла ошибка при создании DNS-записи:  $dns_response <br>";
        return;
    }

    // Создаем DNS A-запись 'www' на IP
    $www_dns_data = array(
        'type' => 'A',
        'name' => 'www',
        'content' => $ip_address,
        'proxied' => true
    );

    $ch = curl_init("https://api.cloudflare.com/client/v4/zones/$zone_id/dns_records");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($www_dns_data));

    $www_dns_response = curl_exec($ch);
    $www_dns_http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // Обрабатываем ответ от сервера
    if ($www_dns_http_code !== 200) {
        echo " Произошла ошибка при создании DNS-записи для 'www':  $www_dns_response  <br>";
        return;
    }

    echo " $domain_name успешно добавлен в Cloudflare, функция 'Всегда использовать HTTPS' включена, и DNS-записи созданы!<br>";
}
?>
